import java.util.ArrayList;
import java.util.Random;

import enumerate.Action;

public class Rule {
	public PositionType positionType;
	public Action enemyAction;
	public ArrayList<ActionData> acts;
	
	private Random _random = new Random();
	
	public int getThresholdedActionID(int playerEnergy) {
		try {
			ArrayList<Integer> availdata = new ArrayList<Integer>();
			ArrayList<Integer> val = new ArrayList<Integer>();
			float avgscore = 0;
			float thresh = 0;
						
			for(int i = 0 ; i < acts.size() ; i++) {
				if(acts.get(i).getEnergyConsumed() <= playerEnergy) {
					availdata.add(i);
					avgscore += acts.get(i).score;
				}
			}

			avgscore /= (float)availdata.size();
			thresh = avgscore * SimpleTraining.ruleThreshold;
			
			for(int i = 0 ; i < availdata.size() ; i++) {
				int id = availdata.get(i);
				if(acts.get(id).score >= thresh)
					val.add(id);
			}
			
			if(val.size() <= 0) {
				return -1;
			}
			else {
				return val.get(_random.nextInt(val.size()));
			}
		} catch (Exception e) {
			e.printStackTrace();
			return -1;
		}
	}
	
	public int getBestActionID(int playerEnergy) {
		try {
			if(acts == null || acts.size() <= 0)
				return -1;
			
			int val = -1;
			for(int i = 0 ; i < acts.size() ; i++) {
				if(acts.get(i).getEnergyConsumed() > playerEnergy)
					continue;
				
				if(val < 0)
					val = i;
				else if(acts.get(i).score > acts.get(val).score)
					val = i;
				else if(acts.get(i).score == acts.get(val).score && _random.nextInt(10) > 5) //..may be replaced if scores are equals
					val = i;
			}
			
			return val;
			
		} catch (Exception e) {
			e.printStackTrace();
			return -1;
		}
	}
	
	public Rule unsaveClone() {
		Rule val = new Rule();
		val.positionType = this.positionType;
		val.enemyAction = this.enemyAction;
		val.acts = new ArrayList<ActionData>();
		for(ActionData a : this.acts)
			val.acts.add(a.unsaveClone());
		return val;
	}
}
