
import aiinterface.CommandCenter;
import enumerate.Action;
import simulator.Simulator;
import struct.FrameData;
import struct.GameData;
import struct.CharacterData;

class MyStateMachine extends FiniteStateMachine{

	public MyStateMachine(GameData gd, boolean player) {
		
		//States:
		Aggressive aggressive = new Aggressive(gd, player);
		Defensive defensive = new Defensive(gd, player);
		AerialAggressive AAggressive = new AerialAggressive(gd, player);

		aggressive.transitions.add(new ToDefensive(defensive));
		defensive.transitions.add(new ToAggressive(aggressive));
		
		states.add(aggressive);
		states.add(defensive);
		
	}
	
	@Override
	Action update(CharacterData mySelf , CharacterData enemy, Simulator sim, FrameData frameData, boolean playerNumber, GameData gd, CommandCenter cc) {
		
		EvaluateTransitions(mySelf, enemy, frameData);
		return activeState.onUpdate( mySelf ,  enemy, sim, frameData, playerNumber, gd, cc);
	}
	
	private void EvaluateTransitions(CharacterData mySelf , CharacterData enemy, FrameData fd) {
		for (FSMTransition fsmTransition : activeState.transitions) {
			if(fsmTransition.isValid(mySelf, enemy, fd)) {
				activeState = fsmTransition.getNextState();
			}
		}
	}
	
}
